﻿/*-------------------------------------------------------------------------
 Abstract class of tracing cryptographic processing.

 File name   : Tracer.cs
 Version     : Version 1.1
 Created     : Apr/20/2009
 Last update : Jun/27/2011
 Desgined by : Toshihiro Katashita
 
 
 Copyright (C) 2009 - 2011 AIST
 
 By using this code, you agree to the following terms and conditions.
 
 This code is copyrighted by AIST ("us").
 
 Permission is hereby granted to copy, reproduce, redistribute or
 otherwise use this code as long as: there is no monetary profit gained
 specifically from the use or reproduction of this code, it is not sold,
 rented, traded or otherwise marketed, and this copyright notice is
 included prominently in any copy made.
 
 We shall not be liable for any damages, including without limitation
 direct, indirect, incidental, special or consequential damages arising
 from the use of this code.
 
 When you publish any results arising from the use of this code, we will
 appreciate it if you can cite our webpage
 (http://staff.aist.go.jp/akashi.satoh/SASEBO/en/).
 -------------------------------------------------------------------------*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Diagnostics;

namespace Tracer
{
  //================================================================ TracerReport
  public struct TracerReport
  {
    public int num_trace;
    public byte[] text_in;
    public byte[] text_out;
    public byte[] text_ans;

    //------------------------------------------------ Constructor
    public TracerReport(int num_trace, byte[] text_in, byte[] text_out, byte[] text_ans)
    {
      this.num_trace = num_trace;
      this.text_in = (byte[])text_in.Clone();
      this.text_out = (byte[])text_out.Clone();
      this.text_ans = (byte[])text_ans.Clone();
    }
  }
  

	//================================================================ Tracer
  public abstract class Tracer
  {
		//************************************************ Variable
		protected BackgroundWorker worker;

		//************************************************ BackgroudWorker
		//------------------------------------------------ addBGWorker_ConpletedEventHandler()
    public void addBGWorker_CompletedEventHandler (RunWorkerCompletedEventHandler handler)
    {
      worker.RunWorkerCompleted += handler;
    }

		//------------------------------------------------ addBGWorker_ProgressChangedEventHandler()
    public void addBGWorker_ProgressChangedEventHandler (ProgressChangedEventHandler handler)
    {
      worker.ProgressChanged += handler;
    }

		//------------------------------------------------ worker_DoWork()
		private void worker_DoWork(object sender, DoWorkEventArgs e) {}

		//------------------------------------------------ run()
		public void run()    { worker.RunWorkerAsync(); }

		//------------------------------------------------ cansel()
		public void cancel() { worker.CancelAsync(); }
  }
}
